Subject: [dhcwg] Some comments regarding draft-ietf-dhc-dhcpv6-unknown-msg-01

From: Marcin Siodelski <[email-masked]>
Date: Mon, 29 Jul 2013 00:37:36 +0200

I have read the draft-ietf-dhc-dhcpv6-unknown-msg-01 and I support this
work move forward.

Short comment on this.

It would be good to distinguish between the term "intended recipient" and
"recipient". From the context I understand that the intended recipient is
used with regards to the target for the message being passed through relays
and the recipient is a term used to describe a host which is currently
holding a message. Perhaps this clarification could be placed in the
glossary or somewhere in the text?

Consider this:
"... the message is valid for constructing a new Relay-forward message if
the recipient is a relay agent, the relay agent does not identify itself as
the intended recipient, and the message is not a Relay-Reply message".

There is a mix-up of these two terms which may suggest that the message is
sent to a wrong relay which is  not an "intended recipient", while the
sentence is actually meant to tell that the relay is not a target for the
message being encapsulated.

There is also another sentence:
"A standards-complient DHCP server will never send a message to the a relay
other than in response to a message from a relay, so there should never be
a case where a relay receives a message for which it is the intended
receipient, but is not able to recognize that it is the intended recipient
for the message".

I have to admit that I had to read this sentence 5 times before I caught
the idea what it is about. It should be simplified, perhaps split into
multiple simple sentences. And the last part could be maybe written as:
"...but is not able to recognize it."

Also, the first part may be wrong in a light of rfc3315, section 19.1.1
which says that server may send Reconfigure in the Relay-Reply message and
since it is server initiated message, it is not sent "in response to a
message from relay" as stated in the bullet.

Cheers,
Marcin

---

From: Ted Lemon <[email-masked]>
Date: Sun, 28 Jul 2013 22:42:28 +0000

On Jul 29, 2013, at 12:37 AM, Marcin Siodelski <[email-masked]> wrote:
> Also, the first part may be wrong in a light of rfc3315, section 19.1.1 which says that server may send Reconfigure in the Relay-Reply message and since it is server initiated message, it is not sent "in response to a message from relay" as stated in the bullet.

Those messages are never sent to relay agents.

Your other comments sound right to me, and I don't mean to say that the last comment doesn't require clarification, just that this is why the text currently reads that way.

Thanks for doing the review!

---

From: Marcin Siodelski <[email-masked]>
Date: Mon, 29 Jul 2013 09:05:16 +0200

On Mon, Jul 29, 2013 at 12:42 AM, Ted Lemon <[email-masked]> wrote:

> According to RFC3315, server may use Relay-Reply message if it can't send
Reconfigure directly to the client:

"If the server does not have an address to which it can send the
Reconfigure message directly to the client, the server uses a Relay-reply
message (as described in section 20.3) to send the Reconfigure message to a
relay agent that will relay the message to the client."

So, my understanding was that this is the server-initiated message which is
NOT sent in response to relay's message. IMO, this invalidates the first
part of the bullet which says "A standards-complient DHCP server will never
send a message to relay other than in response to a message from a relay.."

Marcin

---

From: Ted Lemon <[email-masked]>
Date: Mon, 29 Jul 2013 07:33:18 +0000

On Jul 29, 2013, at 9:05 AM, Marcin Siodelski <[email-masked]> wrote:
> According to RFC3315, server may use Relay-Reply message if it can't send Reconfigure directly to the client:

Right.   That's a relay-reply message, not a reconfigure message.

---

From: Cong Liu <[email-masked]>
Date: Mon, 29 Jul 2013 15:48:17 +0800

Hi Ted,

This relay-reply message is not a response to relay's message.

Cong

2013/7/29 Ted Lemon <[email-masked]>

> _______________________________________________
> dhcwg mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dhcwg
>

---

From: Tomek Mrugalski <[email-masked]>
Date: Mon, 29 Jul 2013 09:49:46 +0200

> Right.   That's a relay-reply message, not a reconfigure message.
Yes, but the message type is irrelevant. Marcin's point was that
the draft says that that server will never send a message that is not a
response to a message from a relay, which is not true.

Note that the draft says nothing about message types. Here's part of the
text that needs to be updated in my opinion: "A standards-compliant DHCP
server will never send a message to the a relay other than in response
to a message from a relay,...".

---

From: Ted Lemon <[email-masked]>
Date: Mon, 29 Jul 2013 07:52:52 +0000

> to a message from a relay,...".

What I am getting at is that that text is referring to messages whose final destination is the relay.   Relay-replies are *to* the relay, but that is not the final destination of the communication, and the relay doesn't have to do anything special with them—it just unwraps the enclosed message and forwards it to the specified address.

---

From: Qi Sun <[email-masked]>
Date: Mon, 29 Jul 2013 10:04:01 +0200

Hi Tomek ,

> response to a message from a relay, which is not true.

What the server sends out is a Relay-Reply message, rather than a Reconfigure message. The Relay-reply message is the message that in response to the relay agent.

Best Regards,
Qi

---

From: Qi Sun <[email-masked]>
Date: Mon, 29 Jul 2013 10:06:34 +0200

Hi Marcin ,

Thanks for the review! 

> It would be good to distinguish between the term "intended recipient" and "recipient". From the context I understand that the intended recipient is used with regards to the target for the message being passed through relays and the recipient is a term used to describe a host which is currently holding a message. Perhaps this clarification could be placed in the glossary or somewhere in the text?
> 
> Consider this:
> "... the message is valid for constructing a new Relay-forward message if the recipient is a relay agent, the relay agent does not identify itself as the intended recipient, and the message is not a Relay-Reply message".
> 
> There is a mix-up of these two terms which may suggest that the message is sent to a wrong relay which is  not an "intended recipient", while the sentence is actually meant to tell that the relay is not a target for the message being encapsulated.

How about the following text:

"... the message is valid for constructing a new Relay-forward message if a relay agent receives the message, but the relay agent does not identify itself as the target of the message, and the message is not a Relay-Reply message."

Is the usage of 'target' here is precise? 

Best Regards,
Qi

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Mon, 29 Jul 2013 08:32:46 +0000

I wonder if reworking the draft a bit would be worthwhile. In some cases it makes statements that could be dangerous in the long run.

The basic concept is that a received msg is either forwarded or consumed by relay.

If the message is a Relay-forw or Relay-Reply, RFC 3315 explains how to handle it.

If not one of these and not one to be consumed by relay (ie, Reconfigure-Reply), it should be forwarded (Relay-forw) unless policy disallows (ie, not client facing interface).

- Bernie (from iPhone)

On Jul 29, 2013, at 10:08 AM, "Qi Sun" <[email-masked]<mailto:[email-masked]>> wrote:

Hi Marcin ,

Thanks for the review!

Consider this:

Best Regards,
Qi

_______________________________________________
dhcwg mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/dhcwg

---

From: Qi Sun <[email-masked]>
Date: Mon, 29 Jul 2013 11:03:01 +0200

Hi Bernie,

> I wonder if reworking the draft a bit would be worthwhile. In some cases it makes statements that could be dangerous in the long run. 

Would you please elaborate so that we could work on them?

Best Regards,
Qi Sun

On 2013-7-29, at 上午10:32, Bernie Volz (volz) wrote:

> On Jul 29, 2013, at 10:08 AM, "Qi Sun" <[email-masked]> wrote:
> 
>> 
>> Hi Marcin ,
>> 
>> Thanks for the review! 
>>

---

From: Qi Sun <[email-masked]>
Date: Mon, 29 Jul 2013 11:06:07 +0200

Tomek ,

> to a message from a relay,...".

What do you think of the text:
NEW:
"A standards-complient DHCP server will never send a message to a relay for which the relay is the the intended recipient,  but is not able to recognize it."

Would it resolve the confusion?

Thanks,
Qi

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Mon, 29 Jul 2013 09:14:36 +0000

One example was the text about standards compliant server not sending msgs.

I really think keeping it much simpler to say a relay that receives a msg that is not a relay-forw, relay-reply, or other message explicitly intended to be processed by the relay as per some RFC should forward the message in a Relay-Forw.

Future documents may define messages that a relay must process (rather than forwarding), though existing relays will forward these until updated. Servers must drop packets that they are not to process.

That's about it.

- Bernie (from iPhone)

On Jul 29, 2013, at 11:03 AM, "Qi Sun" <[email-masked]<mailto:[email-masked]>> wrote:

Hi Bernie,

Best Regards,
Qi Sun

- Bernie (from iPhone)

Hi Marcin ,

Thanks for the review!

Consider this:

Best Regards,
Qi

---

From: "Bernie Volz (volz)" <[email-masked]>
Date: Mon, 29 Jul 2013 09:20:33 +0000

BTW - it may be useful to assure relays have configuration as to whether they do forwarding (Relay-Forw) for specific interfaces; for example this setting should be off if dhcp clients are not expected to be on a particular interface.

This would assure that on server facing interfaces, a future server to relay message which the relay doesn't support isn't forwarded back to server (but not a big deal if it happens as server must ignore that msg).

- Bernie (from iPhone)

On Jul 29, 2013, at 11:14 AM, "Bernie Volz (volz)" <[email-masked]<mailto:[email-masked]>> wrote:

That's about it.

- Bernie (from iPhone)

Hi Bernie,

Best Regards,
Qi Sun

- Bernie (from iPhone)

Hi Marcin ,

Thanks for the review!

Consider this:

Best Regards,
Qi

---

From: Marcin Siodelski <[email-masked]>
Date: Mon, 29 Jul 2013 13:12:34 +0200

On Mon, Jul 29, 2013 at 10:04 AM, Qi Sun <[email-masked]> wrote:

> What the server sends out is a Relay-Reply message, rather than a
> Reconfigure message. The Relay-reply message is the message that in
> response to the relay agent.
>
> We circle around the actual problem. Yes, the Relay-reply is most of the
time sent in response to the relay agent, but there are some cases when the
server initiates the communication and sends the Relay-reply message which
 is not generated as a response to the message sent from relay (RFC3315,
19.1.1).
Note that this doesn't change anything in the definition of the "valid"
message that you specify in the draft. It only invalidates the statement in
one of the bullets that explain why the definition has been specified as it
is.

Marcin

---

From: Marcin Siodelski <[email-masked]>
Date: Mon, 29 Jul 2013 13:18:30 +0200

On Mon, Jul 29, 2013 at 10:06 AM, Qi Sun <[email-masked]> wrote:

> a relay agent receives the message, but the relay agent does not identify
> itself as the target of the message, and the message is not a Relay-Reply
> message."
>
> Yes. It sounds much clearer now.